VARIABLE MY_FRAME
    VARIABLE MY_MENUBAR
        VARIABLE MY_MENU
            VARIABLE MY_MENUITEM_CLOSE
                VARIABLE MY_MENUITEM_CLOSE_ACTION
            VARIABLE MENU_ITEM_ABOUT

: FRAME_TITLE S" Forth Frame" ;
: FILE_MENU_TITLE S" File" ;
: ENV_MENU_TITLE S" Environment" ;
: HELP_MENU_TITLE S" Help" ;
: MENU_ITEM_CLOSE S" Close" ;
: MENU_ITEM_ABOUT_LABEL S" About..." ;

: CREATE_FRAME     ( title - java.awt.Frame )    TOSTRING [[ SWAP java.awt.Frame java::new ;
: CREATE_MENUBAR   (       - java.awt.MenuBar )           [[ java.awt.MenuBar java::new ;
: CREATE_MENU      ( label - java.awt.Menu )     TOSTRING [[ SWAP java.awt.Menu java::new ;
: CREATE_MENU_ITEM ( label - java.awt.MenuItem ) TOSTRING [[ SWAP java.awt.MenuItem java::new ;
: ADD_MENU         ( menu menubar - )            [[ ROT ROT java::call add ;
: ADD_MENU_ITEM    ( menuitem menu - )           [[ ROT ROT java::call add ;
: SET_ACTION       ( word adapter - )            [[ ROT ROT @ java::call setAction ;

FRAME_TITLE CREATE_FRAME MY_FRAME !

[[ 200 400 MY_FRAME @ java::call setSize

CREATE_MENUBAR MY_MENUBAR !
FILE_MENU_TITLE CREATE_MENU MY_MENU !
MENU_ITEM_CLOSE CREATE_MENU_ITEM MY_MENUITEM_CLOSE !

: CLOSEWORD [[ MY_FRAME @ java::call dispose ;

[[ com.mistybeach.forth.javautil.ForthActionAdapter java::new
MY_MENUITEM_CLOSE_ACTION !

' CLOSEWORD MY_MENUITEM_CLOSE_ACTION SET_ACTION
[[ MY_MENUITEM_CLOSE_ACTION @ MY_MENUITEM_CLOSE @ java::call addActionListener

[[ MY_MENU @ MY_MENUBAR @ java::call add
ENV_MENU_TITLE CREATE_MENU MY_MENUBAR @ ADD_MENU
HELP_MENU_TITLE CREATE_MENU MY_MENUBAR @ ADD_MENU

[[ MY_MENUITEM_CLOSE @ MY_MENU @ java::call add
[[ MY_MENUBAR @ MY_FRAME @ java::call setMenuBar
[[ MY_FRAME @ java::call show
FORGET MY_FRAME
